using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using ReflectionIT.UserSettings;

namespace Test
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Button buttonMRUAdd;
		private System.Windows.Forms.TextBox textBoxMRU;
		private System.Windows.Forms.ListBox listBoxMRU;

		private MostRecentlyUsedList _mru;
		private System.Windows.Forms.CheckBox checkBox1;
		private System.Windows.Forms.Button button1;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			// Get UserSettings
			Program.Settings.RegisterForm(this.Name, this);
			_mru = (MostRecentlyUsedList)Program.Settings.GetSetting("mru",  new MostRecentlyUsedList(7));
			checkBox1.Checked = (bool)Program.Settings.GetSetting("checked",  true);
			listBoxMRU.DataSource = _mru;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.buttonMRUAdd = new System.Windows.Forms.Button();
			this.textBoxMRU = new System.Windows.Forms.TextBox();
			this.listBoxMRU = new System.Windows.Forms.ListBox();
			this.checkBox1 = new System.Windows.Forms.CheckBox();
			this.button1 = new System.Windows.Forms.Button();
			this.groupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// groupBox1
			// 
			this.groupBox1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.groupBox1.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.buttonMRUAdd,
																					this.textBoxMRU,
																					this.listBoxMRU});
			this.groupBox1.Location = new System.Drawing.Point(16, 48);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(304, 280);
			this.groupBox1.TabIndex = 3;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Most Recently Used List";
			// 
			// buttonMRUAdd
			// 
			this.buttonMRUAdd.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.buttonMRUAdd.Location = new System.Drawing.Point(256, 248);
			this.buttonMRUAdd.Name = "buttonMRUAdd";
			this.buttonMRUAdd.Size = new System.Drawing.Size(40, 23);
			this.buttonMRUAdd.TabIndex = 5;
			this.buttonMRUAdd.Text = "Add";
			this.buttonMRUAdd.Click += new System.EventHandler(this.buttonMRUAdd_Click);
			// 
			// textBoxMRU
			// 
			this.textBoxMRU.Anchor = ((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.textBoxMRU.Location = new System.Drawing.Point(8, 248);
			this.textBoxMRU.Name = "textBoxMRU";
			this.textBoxMRU.Size = new System.Drawing.Size(240, 20);
			this.textBoxMRU.TabIndex = 4;
			this.textBoxMRU.Text = "";
			// 
			// listBoxMRU
			// 
			this.listBoxMRU.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.listBoxMRU.Location = new System.Drawing.Point(8, 24);
			this.listBoxMRU.Name = "listBoxMRU";
			this.listBoxMRU.Size = new System.Drawing.Size(288, 212);
			this.listBoxMRU.TabIndex = 3;
			// 
			// checkBox1
			// 
			this.checkBox1.Location = new System.Drawing.Point(16, 16);
			this.checkBox1.Name = "checkBox1";
			this.checkBox1.TabIndex = 4;
			this.checkBox1.Text = "checkBox1";
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(248, 16);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(72, 23);
			this.button1.TabIndex = 5;
			this.button1.Text = "Form2...";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// Form1
			// 
			this.AcceptButton = this.buttonMRUAdd;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(328, 334);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.button1,
																		  this.checkBox1,
																		  this.groupBox1});
			this.MinimumSize = new System.Drawing.Size(256, 312);
			this.Name = "Form1";
			this.StartPosition = System.Windows.Forms.FormStartPosition.Manual;
			this.Text = "Form1";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.Form1_Closing);
			this.groupBox1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Add the Text to the MRU and bind it to the datasource
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void buttonMRUAdd_Click(object sender, System.EventArgs e) {
			_mru.Add(textBoxMRU.Text);
			textBoxMRU.Clear();
			textBoxMRU.Focus();

			listBoxMRU.DataSource = null; // force update
			listBoxMRU.DataSource = _mru;
		}

		/// <summary>
		/// Save the MRU and checkBox1.Checked to the UserSettings
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void Form1_Closing(object sender, System.ComponentModel.CancelEventArgs e) {
			Program.Settings.SaveSetting("mru",  _mru);
			Program.Settings.SaveSetting("checked",  checkBox1.Checked);
			Program.Settings.Close();
		}

		private void button1_Click(object sender, System.EventArgs e) {
			using (Form2 f = new Form2()) {
				f.ShowDialog();
			}
		}
	}
}
